//---------------------------------------------------------------------------------
// File Name: Debug.h
//
// Copyright (C) 2004 - 2006 True Axis Pty Ltd, Australia.
// All Rights Reserved.
//
//---------------------------------------------------------------------------------


#ifndef TA_DEBUG_H
#define TA_DEBUG_H

#ifndef TA_COMMON_H
#include "Common.h"
#endif 



namespace TA
{

#define lllOOOOlOl(lllOOOllOO) TA::Debug::Output(lllOOOllOO);

#ifdef _DEBUG
	#ifdef TA_IN_PLACE_ASSERT
		#if defined (TA_GCC_X86_INLINE_ASM)
			#define TA_ASSERT(x)			\
				do							\
				{							\
					if (!(x))				\
					{						\
						asm("int $3")		\
					}						\
				} while (0)
		#elif defined(TA_MSVC_X86_INLINE_ASM)
			#define TA_ASSERT(x)			\
				do							\
				{							\
					if (!(x))				\
					{						\
						__asm { int 3 }		\
					}						\
				} while (0)
		#endif
		#define lOOOOOOllO(x, lllOOOOOll) TA_ASSERT(x)
	#else
		#define TA_ASSERT(x) do { if (!(x)) TA::Debug::lllOOOOlll(__FILE__, __LINE__, #x, 0); } while (0)
		#define lOOOOOOllO(x, lllOOOOOll) do { if (!(x)) TA::Debug::lllOOOOlll(__FILE__, __LINE__, #x, lllOOOOOll); } while (0)
		namespace Debug
		{
			extern void TAC_CALL lllOOOOlll(const char* lllOOOOOOO, int lllOOOOOOl, const char* lllOOOOOlO, const char* lllOOOOOll);
		}
	#endif
	#define TA_VERIFY(x) TA_ASSERT(x)
	#define lllOOOllOl TA_ASSERT(0)
	#define lllOOOlllO(x) TA_ASSERT(x)
	#define lOlOOOlllO(x, lllOOOOOll) lOOOOOOllO(x, lllOOOOOll)
	#define lOlOOlOOOO(lllOOOOOll) lOOOOOOllO(0, lllOOOOOll)
	#ifdef TA_WARNING_AS_ASSERT
		#define lOOOlllOlO(x, lllOOOOOll) lOOOOOOllO(x, lllOOOOOll)
	#else
		#define lOOOlllOlO(x, lllOOOOOll) do { if (!(x)) TA::Debug::llOlllllll(__FILE__, __LINE__, #x, lllOOOOOll); } while (0)
		namespace Debug
		{
			extern void TAC_CALL llOlllllll(const char* lllOOOOOOO, int lllOOOOOOl, const char* lllOOOOOlO, const char* lllOOOOOll);
		}
	#endif  
#else 
	
	#define TA_ASSERT(x)
	#define TA_VERIFY(x) x
	
	#define lOOOOOOllO(x, lllOOOOOll)
	#ifdef TA_MSVC
		#define lllOOOllOl __assume(0) 
		#define lllOOOlllO(x) __assume(x) 
		#define lOlOOOlllO(x, lllOOOOOll) __assume(x)
	#else
		#define lllOOOllOl
		#define lllOOOlllO(x)
		#define lOlOOOlllO(x, lllOOOOOll)
	#endif
	#define lOlOOlOOOO(lllOOOOOll) lOOOOOOllO(0, lllOOOOOll)
	#define lOOOlllOlO(x, lllOOOOOll) lOOOOOOllO(x, lllOOOOOll)
#endif 

#ifdef _DEBUG

namespace Debug
{	
	void TAC_CALL OpenOutputFile(const char* szFileName);
	void TAC_CALL CloseOutputFile();
	void TAC_CALL Output(const char* szText);
	void TAC_CALL SetDebugAssertsEnable(bool bEnabled);
	void TAC_CALL SetExitWitFailureOnAssert(bool bEnabled);	

}
#endif 

}

#endif 

