unit TaTypes;

interface
	
type
    ta_u32 = Word;   
    pta_u32  = ^ta_u32;
    ta_s32 = Integer;
    TTaBool = Boolean;
    TTaChar = Char;
    PTaChar = ^TTaChar;
    PVoid = Pointer;
    PInt = ^Integer;
           
    TTaPhysics = record data: integer; end;
    PTaPhysics = ^TTaPhysics;
    TTaStaticObject = record data: integer; end;
    PTaStaticObject = ^TTaStaticObject;
    TTaDynamicObject = record data: integer; end;
    PTaDynamicObject = ^TTaDynamicObject;    
    TTaCollision = record data: array [0..32] of Integer; end;
    PTaCollision = ^TTaCollision;
    TTaSurfaceAttribute = record data: integer; end;
    PTaSurfaceAttribute = ^TTaSurfaceAttribute;
    TTaLineIntersection = record data: integer; end;
    PTaLineIntersection = ^TTaLineIntersection;
    TTaPhysicsJoint = record data: integer; end;
    PTaPhysicsJoint = ^TTaPhysicsJoint;
    TTaCollisionObjectCombo = record data: integer; end;
    PTaCollisionObjectCombo = ^TTaCollisionObjectCombo;
    TTaCollisionObjectAABBMesh = record data: integer; end;
    PTaCollisionObjectAABBMesh = ^TTaCollisionObjectAABBMesh;
    TTaCollisionObjectComplex = record data: integer; end;
    PTaCollisionObjectComplex = ^TTaCollisionObjectComplex;     
    TTaCollisionObject = record data: integer; end;
    PTaCollisionObject = ^TTaCollisionObject;


    TTaVec3 = record
        x: Single;
        y: Single;
        z: Single;
        padding: Single;
        end;     
    PTaVec3 = ^TTaVec3;
      
    TTaMat33 = record
        v3X: TTaVec3;
        v3Y: TTaVec3;
        v3Z: TTaVec3;
        end;     
    PTaMat33 = ^TTaMat33;
     
    TTaMFrame = record
        m33Rotation: TTaMat33;
        v3Translation: TTaVec3;
        end;     
    PTaMFrame = ^TTaMFrame;

    TTaEulerAngles = record
        x: Single;
        y: Single;
        z: Single;
        end;     
    PTaEulerAngles = ^TTaEulerAngles;

    TTaAABB = record
        v3Center: TTAVec3;
        v3Extent: TTAVec3;
        end;     
    PTaAABB = ^TTaAABB;
         

    TTaDynamicVsDynamicCollisionTestCallBack  = function(
        var objectA : TTaDynamicObject;
        var objectB : TTaDynamicObject) : TTaBool; stdcall;                              
    TTaDynamicVsStaticCollisionTestCallBack  = function(
        var objectA : TTaDynamicObject;
        var objectB : TTaStaticObject) : TTaBool; stdcall;
    TTaPreProcessCollisionCallBack  = function(var collision : TTaCollision) : TTaBool; stdcall;
    TTaPostProcessCollisionCallBack  = procedure(var collision : TTaCollision); stdcall;



const
	TaTrue: TTaBool = True;
	TaFalse: TTaBool = False;
	TA_COLLISION_FLAG_CONSTRAIN_IN_BOTH_DIRECTIONS =		$1;
	TA_COLLISION_FLAG_FRICTION =							$2;
	TA_COLLISION_FLAG_FRICTION_GENERATING_IMPULSE =			$4;
	TA_COLLISION_FLAG_NO_FRICTION =							$8;
	TA_COLLISION_FLAG_JOINT =								$10;
	TA_COLLISION_FLAG_JOINT_LIMIT =							$20;
	TA_COLLISION_FLAG_COLLISION_OCCURRED =					$40;
	TA_COLLISION_FLAG_DISABLE_PUSHOUT =						$80;
	TA_COLLISION_FLAG_MARKED =								$200;
	TA_COLLISION_FLAG_RESTITUTION_CALCULATED =				$400;
	TA_COLLISION_FLAG_OBJECTA_SOLID = 						$1000;
	TA_COLLISION_FLAG_OBJECTB_SOLID = 						$2000;
	TA_COLLISION_FLAG_NEW_COLLISION = 						$4000;
	TA_COLLISION_FLAG_ROTATION_CONSTRAINT =					$8000;
	TA_COLLISION_FLAG_OBJECTB_INFINITE_MASS =				$10000;
	TA_COLLISION_FLAG_DEPTH_CALCULATED_FROM_TIME =			$20000;
	TA_COLLISION_FLAG_USE_PUSH_OUT_MODIFIER =				$40000;


implementation

end.
