//---------------------------------------------------------------------------------
//
// Autogenerated from CreateDllWrapper.pl
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia.
// All Rights Reserved.
//
//---------------------------------------------------------------------------------

#ifndef TA_COLLISION_WRAPPER_HPP
#define TA_COLLISION_WRAPPER_HPP

namespace TA
{

class Collision
{
public:

	enum
	{
		FLAG_CONSTRAIN_IN_BOTH_DIRECTIONS =		0x1,
		FLAG_FRICTION =							0x2,
		FLAG_FRICTION_GENERATING_IMPULSE =		0x4,
		FLAG_NO_FRICTION =						0x8,
		FLAG_JOINT =							0x10,
		FLAG_JOINT_LIMIT =						0x20,
		FLAG_COLLISION_OCCURRED =				0x40,
		FLAG_DISABLE_PUSHOUT =					0x80,
		FLAG_MARKED =							0x200,
		FLAG_RESTITUTION_CALCULATED =			0x400,
		FLAG_OBJECTA_SOLID = 					0x1000,
		FLAG_OBJECTB_SOLID = 					0x2000,
		FLAG_NEW_COLLISION = 					0x4000,
		FLAG_ROTATION_CONSTRAINT =				0x8000,
		FLAG_OBJECTB_INFINITE_MASS =			0x10000,
		FLAG_DEPTH_CALCULATED_FROM_TIME =		0x20000,
		FLAG_USE_PUSH_OUT_MODIFIER =			0x40000,
	};

	void Clear();

	void Initialise(
		DynamicObject* pNewObjectA,
		DynamicObject* pNewObjectB,
		float fNewTime,
		float fNewIntersectingDepth,
		const Vec3& v3NewPosition,
		const Vec3& v3NewNormal);

	const Vec3& GetPosition() const;

	void SetPosition(
		const Vec3& v3Position);

	const Vec3& GetNormal() const;

	void SetNormal(
		const Vec3& v3Normal);

	DynamicObject* GetObjectA() const;

	DynamicObject* GetObjectB() const;

	void SetObjectA(
		DynamicObject* pDynamicObject);

	void SetObjectB(
		DynamicObject* pDynamicObject);

	CollisionObject* GetCollisionObjectA();

	CollisionObject* GetCollisionObjectB();

	const CollisionObject* GetCollisionObjectA() const;

	const CollisionObject* GetCollisionObjectB() const;

	void SetCollisionObjectA(
		CollisionObject* pCollisionObjectA);

	void SetCollisionObjectB(
		CollisionObject* pCollisionObjectB);

	int GetFlags() const;

	void SetFlags(
		u32 nFlags);

	u32& Flags();

	float GetRestitution() const;

	void SetRestitution(
		float fRestitution);

	float GetImpulse() const;

	void SetImpulse(
		float fImpulse);

	float GetFrictionCoefficient() const;

	void SetFrictionCoefficient(
		float fFrictionCoefficient);

	float GetTime() const;

	void SetTime(
		float fTime);

	float GetIntersectingDepth() const;

	void SetIntersectingDepth(
		float fIntersectingDepth);

	u32 GetCollisionIdA() const;

	void SetCollisionIdA(
		u32 nCollisionIdA);

	u32 GetCollisionIdB() const;

	void SetCollisionIdB(
		u32 nCollisionIdB);

	u32 GetAttributeA() const;

	void SetAttributeA(
		u32 nAttributeA);

	u32 GetAttributeB() const;

	void SetAttributeB(
		u32 nAttributeB);

	PhysicsJoint* GetJoint();

	const PhysicsJoint* GetJoint() const;

	bool CollisionOccurred() const;

	Collision* GetNext();

	Collision() {};

private:

	u8 data[128];};

} // namespace TA


#include "Collision.inl"

#endif // TA_COLLISION_WRAPPER_HPP
