//---------------------------------------------------------------------------------
//
// Autogenerated from CreateDllWrapper.pl
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia.
// All Rights Reserved.
//
//---------------------------------------------------------------------------------

#ifndef TA_PHYSICS_WRAPPER_HPP
#define TA_PHYSICS_WRAPPER_HPP

namespace TA
{

class Physics
{
public:

	enum
	{
		FLAG_DYNAMIC_OBJECTS =			0x1,
		FLAG_STATIC_OBJECTS	=			0x2,

		FLAG_ALL_OBJECTS = FLAG_DYNAMIC_OBJECTS | FLAG_STATIC_OBJECTS, //pl. pascal($1 + $2;)
		FLAG_ALL_NON_DYNAMIC_OBJECTS = FLAG_STATIC_OBJECTS, //pl. pascal($2;)

		FLAG_GHOST_OBJECTS =			0x8,
		FLAG_RENDER_COLLISIONS =		0x10,

		FLAG_SPACIAL_DIVISION_MASK =	0x20 + 0x40 + 0x80, 
		FLAG_XY_COLLISION_GRID =		0x20,
		FLAG_XZ_COLLISION_GRID =		0x40,
		FLAG_YZ_COLLISION_GRID =		0x60,
		FLAG_DYNAMIC_OCTREE =			0x80,
	};

	enum
	{
		SPACIAL_DIVISION_TYPE_DYNAMIC_OCTREE = 0,
		SPACIAL_DIVISION_TYPE_XY_COLLISION_GRID = 1,
		SPACIAL_DIVISION_TYPE_XZ_COLLISION_GRID = 2,
		SPACIAL_DIVISION_TYPE_YZ_COLLISION_GRID = 3,
	};

	static void TA_CALL CreateInstance();

	static void TA_CALL DestroyInstance();

	static Physics& TA_CALL GetInstance();

	void SetupSimulation();

	void Update(
		float fDt);

	void Render();

	void AddStaticObject(
		StaticObject* pStaticObject);

	void RemoveStaticObject(
		StaticObject* pStaticObject);

	int AddSurfaceAttribute(
		SurfaceAttribute* pSurfaceAttribute);

	int AddSurfaceAttribute();

	void RemoveSurfaceAttribute(
		int nIndex);

	SurfaceAttribute& GetSurfaceAttribute(
		int nIndex);

	int GetNumSurfaceAttributes();

	void SetDefaultSurfaceAttribute(
		SurfaceAttribute* pSurfaceAttribute);

	const SurfaceAttribute& GetDefaultSurfaceAttribute();

	void AddDynamicObject(
		DynamicObject* pDynamicObject,
		bool bInitiallyMoving = true);

	void RemoveDynamicObject(
		DynamicObject* pDynamicObject);

	void SetDynamicObjectIsMoving(
		DynamicObject* pDynamicObject);

	void SetDynamicObjectAtRest(
		DynamicObject* pDynamicObject);

	void TestLineForCollision(
		const Vec3& v3Start,
		const Vec3& v3Normal,
		float fLength,
		Collision& collision,
		u32 nFlags);

	void TestLineForCollision(
		const Vec3& v3Start,
		const Vec3& v3End,
		Collision& collision,
		u32 nFlags = FLAG_ALL_OBJECTS);

	const Vec3& GetGravity() const;

	void SetGravity(
		const Vec3& v3Gravity);

	void SetRenderCollisionsEnabled(
		bool bValue);

	void SetWorldDimensions(
		const AABB& worldAABB);

	const AABB& GetWorldDimensions();

	void SetMaxNumCollisions(
		int nMaxNumCollisions);

	int GetMaxNumCollisions();

	void SetMaxNumMovingObjects(
		int nMaxNumMovingObjects);

	int GetMaxNumMovingObjects();

	void SetSlowSolverMaxNumCollisions(
		int nSlowSolverMaxNumCollisions);

	int GetSlowSolverMaxNumCollisions();

	void SetSlowSolverMaxNumObjects(
		int nSlowSolverMaxNumObjects);

	int GetSlowSolverMaxNumObjects();

	void SetMaxNumObjectPairs(
		int nMaxNumObjectPairs);

	int GetMaxNumObjectPairs();

	void SetSpacialDivisionType(
		int eSpacialDivisionType);

	int GetSpacialDivisionType();

	void SetSpacialDivisionMinSize(
		float fSpacialDivisionMinSize);

	float GetSpacialDivisionMinSize();

	void SetSpacialDivisionMaxMemory(
		int nSpacialDivisionMaxMemory);

	int GetSpacialDivisionMaxMemory();

	DynamicVsDynamicCollisionTestCallBack GetDynamicVsDynamicCollisionTestCallBack() const;

	void SetDynamicVsDynamicCollisionTestCallBack(
		DynamicVsDynamicCollisionTestCallBack pFnDynamicVsDynamicCollisionTest);

	PreProcessCollisionCallBack GetPreProcessCollisionCallBack() const;

	void SetPreProcessCollisionCallBack(
		PreProcessCollisionCallBack pFnPreProcessCollision);

	PostProcessCollisionCallBack GetPostProcessCollisionCallBack() const;

	void SetPostProcessCollisionCallBack(
		PostProcessCollisionCallBack pFnPostProcessCollision);

	static void TA_CALL CreateInstance(
		const AABB& worldAABB,
		const Vec3& v3Gravity = Vec3(0.0f, -9.81f, 0.0f),
		u32 nFlags = FLAG_XZ_COLLISION_GRID,
		float fMinSpacialDivision = 10.0f,
		int nSpacialDivisionMemory = 0x40000);

private:

	Physics();

	Physics(const Physics& that);

};

} // namespace TA


#include "Physics.inl"

#endif // TA_PHYSICS_WRAPPER_HPP
