{

 Autogenerated from CreateDllWrapper.pl

 Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia.
 All Rights Reserved.

}

unit TaCollision;

interface

uses TaTypes;

const
	TA_COLLISION_FLAG_CONSTRAIN_IN_BOTH_DIRECTIONS : Integer = $1; 
	TA_COLLISION_FLAG_FRICTION : Integer = $2; 
	TA_COLLISION_FLAG_FRICTION_GENERATING_IMPULSE : Integer = $4; 
	TA_COLLISION_FLAG_NO_FRICTION : Integer = $8; 
	TA_COLLISION_FLAG_JOINT : Integer = $10; 
	TA_COLLISION_FLAG_JOINT_LIMIT : Integer = $20; 
	TA_COLLISION_FLAG_COLLISION_OCCURRED : Integer = $40; 
	TA_COLLISION_FLAG_DISABLE_PUSHOUT : Integer = $80; 
	TA_COLLISION_FLAG_MARKED : Integer = $200; 
	TA_COLLISION_FLAG_RESTITUTION_CALCULATED : Integer = $400; 
	TA_COLLISION_FLAG_OBJECTA_SOLID : Integer = $1000; 
	TA_COLLISION_FLAG_OBJECTB_SOLID : Integer = $2000; 
	TA_COLLISION_FLAG_NEW_COLLISION : Integer = $4000; 
	TA_COLLISION_FLAG_ROTATION_CONSTRAINT : Integer = $8000; 
	TA_COLLISION_FLAG_OBJECTB_INFINITE_MASS : Integer = $10000; 
	TA_COLLISION_FLAG_DEPTH_CALCULATED_FROM_TIME : Integer = $20000; 
	TA_COLLISION_FLAG_USE_PUSH_OUT_MODIFIER : Integer = $40000; 

procedure TaCollision_Clear(
	pTaCollision: PTaCollision); stdcall;

procedure TaCollision_Initialise(
	pTaCollision: PTaCollision;
	pNewObjectA : PTaDynamicObject;
	pNewObjectB : PTaDynamicObject;
	fNewTime : Single;
	fNewIntersectingDepth : Single;
	var v3NewPosition : TTaVec3;
	var v3NewNormal : TTaVec3); stdcall;

function TaCollision_GetPosition(
	pTaCollision: PTaCollision) : PTaVec3; stdcall;

procedure TaCollision_SetPosition(
	pTaCollision: PTaCollision;
	var v3Position : TTaVec3); stdcall;

function TaCollision_GetNormal(
	pTaCollision: PTaCollision) : PTaVec3; stdcall;

procedure TaCollision_SetNormal(
	pTaCollision: PTaCollision;
	var v3Normal : TTaVec3); stdcall;

function TaCollision_GetObjectA(
	pTaCollision: PTaCollision) : PTaDynamicObject; stdcall;

function TaCollision_GetObjectB(
	pTaCollision: PTaCollision) : PTaDynamicObject; stdcall;

procedure TaCollision_SetObjectA(
	pTaCollision: PTaCollision;
	pDynamicObject : PTaDynamicObject); stdcall;

procedure TaCollision_SetObjectB(
	pTaCollision: PTaCollision;
	pDynamicObject : PTaDynamicObject); stdcall;

function TaCollision_GetCollisionObjectA(
	pTaCollision: PTaCollision) : PTaCollisionObject; stdcall;

function TaCollision_GetCollisionObjectB(
	pTaCollision: PTaCollision) : PTaCollisionObject; stdcall;

function TaCollision_GetCollisionObjectA2(
	pTaCollision: PTaCollision) : PTaCollisionObject; stdcall;

function TaCollision_GetCollisionObjectB2(
	pTaCollision: PTaCollision) : PTaCollisionObject; stdcall;

procedure TaCollision_SetCollisionObjectA(
	pTaCollision: PTaCollision;
	pCollisionObjectA : PTaCollisionObject); stdcall;

procedure TaCollision_SetCollisionObjectB(
	pTaCollision: PTaCollision;
	pCollisionObjectB : PTaCollisionObject); stdcall;

function TaCollision_GetFlags(
	pTaCollision: PTaCollision) : Integer; stdcall;

procedure TaCollision_SetFlags(
	pTaCollision: PTaCollision;
	nFlags : ta_u32); stdcall;

function TaCollision_Flags(
	pTaCollision: PTaCollision) : pta_u32; stdcall;

function TaCollision_GetRestitution(
	pTaCollision: PTaCollision) : Single; stdcall;

procedure TaCollision_SetRestitution(
	pTaCollision: PTaCollision;
	fRestitution : Single); stdcall;

function TaCollision_GetImpulse(
	pTaCollision: PTaCollision) : Single; stdcall;

procedure TaCollision_SetImpulse(
	pTaCollision: PTaCollision;
	fImpulse : Single); stdcall;

function TaCollision_GetFrictionCoefficient(
	pTaCollision: PTaCollision) : Single; stdcall;

procedure TaCollision_SetFrictionCoefficient(
	pTaCollision: PTaCollision;
	fFrictionCoefficient : Single); stdcall;

function TaCollision_GetTime(
	pTaCollision: PTaCollision) : Single; stdcall;

procedure TaCollision_SetTime(
	pTaCollision: PTaCollision;
	fTime : Single); stdcall;

function TaCollision_GetIntersectingDepth(
	pTaCollision: PTaCollision) : Single; stdcall;

procedure TaCollision_SetIntersectingDepth(
	pTaCollision: PTaCollision;
	fIntersectingDepth : Single); stdcall;

function TaCollision_GetCollisionIdA(
	pTaCollision: PTaCollision) : ta_u32; stdcall;

procedure TaCollision_SetCollisionIdA(
	pTaCollision: PTaCollision;
	nCollisionIdA : ta_u32); stdcall;

function TaCollision_GetCollisionIdB(
	pTaCollision: PTaCollision) : ta_u32; stdcall;

procedure TaCollision_SetCollisionIdB(
	pTaCollision: PTaCollision;
	nCollisionIdB : ta_u32); stdcall;

function TaCollision_GetAttributeA(
	pTaCollision: PTaCollision) : ta_u32; stdcall;

procedure TaCollision_SetAttributeA(
	pTaCollision: PTaCollision;
	nAttributeA : ta_u32); stdcall;

function TaCollision_GetAttributeB(
	pTaCollision: PTaCollision) : ta_u32; stdcall;

procedure TaCollision_SetAttributeB(
	pTaCollision: PTaCollision;
	nAttributeB : ta_u32); stdcall;

function TaCollision_GetJoint(
	pTaCollision: PTaCollision) : PTaPhysicsJoint; stdcall;

function TaCollision_GetJoint2(
	pTaCollision: PTaCollision) : PTaPhysicsJoint; stdcall;

function TaCollision_CollisionOccurred(
	pTaCollision: PTaCollision) : TTaBool; stdcall;

function TaCollision_GetNext(
	pTaCollision: PTaCollision) : PTaCollision; stdcall;

implementation

procedure TaCollision_Clear(
	pTaCollision: PTaCollision); stdcall;
external 'TaPhysics.dll' name '_TaCollision_Clear@4';

procedure TaCollision_Initialise(
	pTaCollision: PTaCollision;
	pNewObjectA : PTaDynamicObject;
	pNewObjectB : PTaDynamicObject;
	fNewTime : Single;
	fNewIntersectingDepth : Single;
	var v3NewPosition : TTaVec3;
	var v3NewNormal : TTaVec3); stdcall;
external 'TaPhysics.dll' name '_TaCollision_Initialise@28';

function TaCollision_GetPosition(
	pTaCollision: PTaCollision) : PTaVec3; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetPosition@4';

procedure TaCollision_SetPosition(
	pTaCollision: PTaCollision;
	var v3Position : TTaVec3); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetPosition@8';

function TaCollision_GetNormal(
	pTaCollision: PTaCollision) : PTaVec3; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetNormal@4';

procedure TaCollision_SetNormal(
	pTaCollision: PTaCollision;
	var v3Normal : TTaVec3); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetNormal@8';

function TaCollision_GetObjectA(
	pTaCollision: PTaCollision) : PTaDynamicObject; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetObjectA@4';

function TaCollision_GetObjectB(
	pTaCollision: PTaCollision) : PTaDynamicObject; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetObjectB@4';

procedure TaCollision_SetObjectA(
	pTaCollision: PTaCollision;
	pDynamicObject : PTaDynamicObject); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetObjectA@8';

procedure TaCollision_SetObjectB(
	pTaCollision: PTaCollision;
	pDynamicObject : PTaDynamicObject); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetObjectB@8';

function TaCollision_GetCollisionObjectA(
	pTaCollision: PTaCollision) : PTaCollisionObject; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetCollisionObjectA@4';

function TaCollision_GetCollisionObjectB(
	pTaCollision: PTaCollision) : PTaCollisionObject; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetCollisionObjectB@4';

function TaCollision_GetCollisionObjectA2(
	pTaCollision: PTaCollision) : PTaCollisionObject; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetCollisionObjectA2@4';

function TaCollision_GetCollisionObjectB2(
	pTaCollision: PTaCollision) : PTaCollisionObject; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetCollisionObjectB2@4';

procedure TaCollision_SetCollisionObjectA(
	pTaCollision: PTaCollision;
	pCollisionObjectA : PTaCollisionObject); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetCollisionObjectA@8';

procedure TaCollision_SetCollisionObjectB(
	pTaCollision: PTaCollision;
	pCollisionObjectB : PTaCollisionObject); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetCollisionObjectB@8';

function TaCollision_GetFlags(
	pTaCollision: PTaCollision) : Integer; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetFlags@4';

procedure TaCollision_SetFlags(
	pTaCollision: PTaCollision;
	nFlags : ta_u32); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetFlags@8';

function TaCollision_Flags(
	pTaCollision: PTaCollision) : pta_u32; stdcall;
external 'TaPhysics.dll' name '_TaCollision_Flags@4';

function TaCollision_GetRestitution(
	pTaCollision: PTaCollision) : Single; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetRestitution@4';

procedure TaCollision_SetRestitution(
	pTaCollision: PTaCollision;
	fRestitution : Single); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetRestitution@8';

function TaCollision_GetImpulse(
	pTaCollision: PTaCollision) : Single; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetImpulse@4';

procedure TaCollision_SetImpulse(
	pTaCollision: PTaCollision;
	fImpulse : Single); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetImpulse@8';

function TaCollision_GetFrictionCoefficient(
	pTaCollision: PTaCollision) : Single; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetFrictionCoefficient@4';

procedure TaCollision_SetFrictionCoefficient(
	pTaCollision: PTaCollision;
	fFrictionCoefficient : Single); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetFrictionCoefficient@8';

function TaCollision_GetTime(
	pTaCollision: PTaCollision) : Single; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetTime@4';

procedure TaCollision_SetTime(
	pTaCollision: PTaCollision;
	fTime : Single); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetTime@8';

function TaCollision_GetIntersectingDepth(
	pTaCollision: PTaCollision) : Single; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetIntersectingDepth@4';

procedure TaCollision_SetIntersectingDepth(
	pTaCollision: PTaCollision;
	fIntersectingDepth : Single); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetIntersectingDepth@8';

function TaCollision_GetCollisionIdA(
	pTaCollision: PTaCollision) : ta_u32; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetCollisionIdA@4';

procedure TaCollision_SetCollisionIdA(
	pTaCollision: PTaCollision;
	nCollisionIdA : ta_u32); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetCollisionIdA@8';

function TaCollision_GetCollisionIdB(
	pTaCollision: PTaCollision) : ta_u32; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetCollisionIdB@4';

procedure TaCollision_SetCollisionIdB(
	pTaCollision: PTaCollision;
	nCollisionIdB : ta_u32); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetCollisionIdB@8';

function TaCollision_GetAttributeA(
	pTaCollision: PTaCollision) : ta_u32; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetAttributeA@4';

procedure TaCollision_SetAttributeA(
	pTaCollision: PTaCollision;
	nAttributeA : ta_u32); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetAttributeA@8';

function TaCollision_GetAttributeB(
	pTaCollision: PTaCollision) : ta_u32; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetAttributeB@4';

procedure TaCollision_SetAttributeB(
	pTaCollision: PTaCollision;
	nAttributeB : ta_u32); stdcall;
external 'TaPhysics.dll' name '_TaCollision_SetAttributeB@8';

function TaCollision_GetJoint(
	pTaCollision: PTaCollision) : PTaPhysicsJoint; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetJoint@4';

function TaCollision_GetJoint2(
	pTaCollision: PTaCollision) : PTaPhysicsJoint; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetJoint2@4';

function TaCollision_CollisionOccurred(
	pTaCollision: PTaCollision) : TTaBool; stdcall;
external 'TaPhysics.dll' name '_TaCollision_CollisionOccurred@4';

function TaCollision_GetNext(
	pTaCollision: PTaCollision) : PTaCollision; stdcall;
external 'TaPhysics.dll' name '_TaCollision_GetNext@4';


end.
